
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ir_filingsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ir_filings = await db.ir_filings.create(
            {
                id: data.id || undefined,
        
        filing_type: data.filing_type
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        filed_at: data.filed_at
        ||
        null
            ,
            
        sec_url: data.sec_url
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ir_filings.setIr_company( data.ir_company || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ir_filings.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: ir_filings.id,
            },
            data.attachments,
            options,
        );
        

        return ir_filings;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ir_filingsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                filing_type: item.filing_type
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                filed_at: item.filed_at
            ||
            null
            ,
            
                sec_url: item.sec_url
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ir_filings = await db.ir_filings.bulkCreate(ir_filingsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < ir_filings.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.ir_filings.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: ir_filings[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return ir_filings;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const ir_filings = await db.ir_filings.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.filing_type !== undefined) updatePayload.filing_type = data.filing_type;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.filed_at !== undefined) updatePayload.filed_at = data.filed_at;
        
        
        if (data.sec_url !== undefined) updatePayload.sec_url = data.sec_url;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        updatePayload.updatedById = currentUser.id;

        await ir_filings.update(updatePayload, {transaction});

        
        
        if (data.ir_company !== undefined) {
            await ir_filings.setIr_company(
              
              data.ir_company,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ir_filings.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: ir_filings.id,
            },
            data.attachments,
            options,
        );
        

        return ir_filings;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ir_filings = await db.ir_filings.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ir_filings) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ir_filings) {
                await record.destroy({transaction});
            }
        });


        return ir_filings;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ir_filings = await db.ir_filings.findByPk(id, options);

        await ir_filings.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ir_filings.destroy({
            transaction
        });

        return ir_filings;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ir_filings = await db.ir_filings.findOne(
            { where },
            { transaction },
        );

        if (!ir_filings) {
            return ir_filings;
        }

        const output = ir_filings.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.ir_company = await ir_filings.getIr_company({
            transaction
        });
        
        
        output.attachments = await ir_filings.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.ir_companies,
        as: 'ir_company',
        
        where: filter.ir_company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.ir_company.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.ir_company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ir_filings',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.sec_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ir_filings',
                        'sec_url',
                        filter.sec_url,
                    ),
                };
            }
            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ir_filings',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            

            
            

            
            if (filter.filed_atRange) {
                const [start, end] = filter.filed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    filed_at: {
                    ...where.filed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    filed_at: {
                    ...where.filed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.filing_type) {
                where = {
                    ...where,
                filing_type: filter.filing_type,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ir_filings.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ir_filings',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ir_filings.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

